/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.kandidatur.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.kandidatur.entity.Kandidatur;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractKandidaturSearch {

  @Inject
  protected transient KandidaturExtendedDAO dao;

  public AbstractKandidaturSearch() {
    super();
  }

  public List<Kandidatur> getSearchResult(KandidaturSearchParameters searchParameters, EagerLoadingCollector<Kandidatur> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Kandidatur> querySearchResult(KandidaturSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
